Affected QGIS version:3.0.0 Regression?: No
Pull Request or Patch supplied:No Resolution: fixed/implemented
Description

Hi, I have PostGIS based layer with numeric field. When i try to edit this field, it is not posible to insert (copy nor write) numbers with

decimal separator. Only integer values are alowed. I try use dot as well as comma but with no luck. Also tried to switch QGIS language

from United States to my system locale (Czech), but this also didn't work.

Postgres field definition is plain numeric (no scale a precision defined)

QGIS field definition said: double, numeric, -1, -1

It works fine in 2.18.14 (with dot or even comma). Same database, same table, same field.

Related issues:

Duplicates QGIS Application - Bug report # 18963: Can not write a decimal in ... Closed 2018-05-16

History

#1 - 2018-04-11 03:31 PM - Alessandro Pasotti

- Status changed from Open to Feedback

- Assignee set to Alessandro Pasotti

I cannot reproduce in current master, would you be able to test a nightly build?

If that still does not work, please attach a minimal project and data (pg_dump) to reproduce the issue.

#2 - 2018-04-13 08:45 AM - David Pavlicek

I have tested this against latest nightly build from OSGeo (3.1.0-master 4c8b1595a9) with same results...

BUT, after bit of fiddling with this, I thing that real isuue is how editing plugin handles decimal number fields without scale and precision in conjunction with

system (Windows) decimal separator settings. When I try to edit decimal number with -1 in scale and precision and with comma (,) as system decimal

separator, it does not work! No matter of source layer type (tested with Postgres, shape and memory layer). There is matrix of all data types I have tested

with comma as system decimal separator:

numeric(10,5)   - WORKS

numeric(-1,-1)  - BROKEN

decimal(10,5)   - WORKS

real(-1,-1)     - BROKEN

double(-1, -1)  - BROKEN

When I set system decimal separator to dot (.) everything works... Unfortunately, I cannot simply change my system settings permanently because there
are lot of other applications and systems that expects comma as system decimal separator (it is default for my locale).

Hope this helps

#3 - 2018-04-13 08:51 AM - Alessandro Pasotti

Thanks for the feedback,

So, basically, the problem looks like that the default editor widget for numeric does not take into account your operating system locale decimal separator

setting?

How are the locale settings in QGIS options?

Would you mind attaching a small screenshot so that I'm sure we are looking to the same widget?

#4 - 2018-04-13 10:00 AM - David Pavlicek

- File qgis_locale_setting.png added

- File layer_definition.png added

- File layer_form.png added

- File system_locale_stting.png added

There are screenshots of my system settings, QGIS settings, Layer definition and its Feature form where i try to put in 123.45 (123,45 respectively)...

#5 - 2018-04-16 05:51 PM - Alessandro Pasotti

- Assignee deleted (Alessandro Pasotti)

- Resolution set to not reproducable

Sorry: I tested this again but I wasn't able to reproduce it on Linux with latest master: I also have "," as a decimal separator and I'm testing with a PostGIS

DB with a "numeric" "-1" "-1" field configuration (just like your attached images).

What happens in my tests is that I can enter a number with both (. and ,) as decimal separator: whenever I press a "," it gets automatically converted to a

".".

#6 - 2018-04-16 09:55 PM - Harrissou Santanna

I don't how or whether this is linked (sorry if it is not) but in another context, i have issues with dot being recognized as decimal separator when editing text

box (see #18656).

#7 - 2018-05-03 08:14 AM - David Pavlicek

Hi again,

i suppose that this issue is specific for Wondows OS and locale with comma as decimal separator. I was able to reproduce it on every machine with

Windows (7 or even 10) in our office.

#8 - 2018-05-03 08:47 AM - David Pavlicek

2025-04-27 2/3



- Status changed from Feedback to Open

#9 - 2018-05-17 05:50 PM - Jesahel Benoist

Similar bug there #18963

#10 - 2018-05-17 06:04 PM - Jürgen Fischer

- Related to Bug report #18963: Can not write a decimal in a real field of a layer spatialite added

#11 - 2018-06-05 09:55 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#12 - 2018-06-05 06:47 PM - Alessandro Pasotti

- Related to deleted (Bug report #18963: Can not write a decimal in a real field of a layer spatialite)

#13 - 2018-06-05 06:47 PM - Alessandro Pasotti

- Duplicates Bug report #18963: Can not write a decimal in a real field of a layer spatialite added

#14 - 2018-06-05 06:48 PM - Alessandro Pasotti

Please have a look to https://issues.qgis.org/issues/18963#note-8 and test the attached snapshot on windows.

#15 - 2018-06-12 08:53 AM - Alessandro Pasotti

- Status changed from Open to Closed

- Resolution changed from not reproducable to fixed/implemented

Fixed with https://github.com/qgis/QGIS/commit/4e37f381dee1e8a54144776c55bedbdf4df14b9b

please test it and report any issue assigning it to me
